#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

class UnionFind {
	private: 
		typedef vector<long> vi;
		vi p; 
		vi rank;

	public: 

		UnionFind(long N){
			rank.assign (N, 0);  p.assign(N,0);
			for(long i =0; i<N; i++)  // inicalmente, o pai de todo mundo aponta para si..
				p[i] = i;
		}


		long findSet(long i){
			if (p[i] == i)
				return i;
			else return p[i] = findSet(p[i]);
		}

		bool isSameSet(long i, long j){
			return (findSet(i) == findSet(j));
		}

		void unionSet(long i, long j){
			if (!isSameSet(i,j)){
				long x = findSet(i);
				long y = findSet(j);

				if (rank[x] > rank[y])
					p[y] = x;
				else {
					p[x] = y;
					if (rank[x] == rank[y])
						rank[y] = rank[y]+1;
				}
			}

		}
};

// par de inteiros: guarda o vertice v e o peso da aresta
typedef pair<long,long> ii;

// todos os vertices v adjacentes a u 
typedef vector<ii> vii;

// lista de adjacencia para todo vertice u do meu grafo..
//vector<vii> AdjList(200);

vector<pair<long, ii> > EdgeList;  //Lista arestas que é um par (w, (u,v))

typedef vector<long> vi;

long A;
long V; 

int  main(int argc, char const *argv[])
{
	cin >> V;
	cin >> A;
	long v, u, w;
	// cria a lista de arestas, onde o peso é o list.first !!!!
	for (long i = 0; i < A; ++i){
		cin >> u >> v >> w;
		EdgeList.push_back(make_pair(w, ii(u, v)));
	}

	// ordena a lista de arestas
	sort(EdgeList.begin(), EdgeList.end());

	//for (long i = 0; i < A; ++i){
	//	printf(" w = %d ** [%d,%d] \n", EdgeList[i].first, EdgeList[i].second.first, EdgeList[i].second.second );
	//}

	long custo = 0;

	UnionFind uf(V+1);

	// consome a lista de arestas....
	for (long i = 0; i < EdgeList.size(); ++i) {
		pair<long,ii> el = EdgeList[i];

		// verifica se u e v nao formam ciclo
		if (!uf.isSameSet(el.second.first, el.second.second)){
			custo = custo + el.first;
			// coloque u e v no mesmo conjunto....
			uf.unionSet(el.second.first, el.second.second);
		}

	}
	bool achou = true;
	for (long i = 1; i < V; ++i){
		if (!uf.isSameSet(i,i+1) ){
			achou = false;
			break;
		}
	}
	if (achou)
		printf("%ld\n", custo);
	else printf("%d\n", -1);

	return 0;
}