//Como usar STL para construir uma lista de adjacencia para representacao de GRAFOS
// Traverse the graph BFS....

#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>

using namespace std;

#define VIS 1
#define NAOVIS 0

typedef pair<int,int> ii;
typedef vector<ii> vii;
// muitos problemas de grafos requerem uso de vetor de visitados, etc...
typedef vector<int> vi;

// a lista de adjacencia é um vetor de vii !!!
vector<vii> AdjList;

//vetor de vertices (VIS ou NAOVIS)
vi vertices;


void printList(int nv){
	for (int i = 0; i <= nv; ++i){
		printf("%d -> ", i );
		for (int j = 0; j < AdjList[i].size(); ++j){
			printf("(%d %d) -> ", AdjList[i][j].first, AdjList[i][j].second);
		}
		printf("\n");
	}
	printf("\n");
}


void bfs(int v){
	queue<int> q;

	q.push(v);  // Coloca o vertice inicial na fila....
	vertices[v] = VIS; // marca u como visitado
	
	// enquanto tiver elemento na fila...
	while (!q.empty()){
		int u = q.front(); q.pop();
		printf("%d ** ", u);
		// para todos os adj v de u
		for (int i = 0; i < AdjList[u].size(); ++i){
			int v = AdjList[u][i].first;
			int w = AdjList[u][i].second;
			if (vertices[v] == NAOVIS){
				q.push(v);
				vertices[v] = VIS;
			}
		}
	}
}


int main(int argc, char const *argv[])
{
	int nv;
	int u,v;

	cin >> nv;

	AdjList.assign(nv+1,vii());
	printList(nv);


	//AdjList.assign(oi.begin(), oi.end());
	vertices.assign(nv+1, NAOVIS);

	// le o grafo... (nao direcionado)
	while(cin >> u >> v){
		AdjList[u].push_back(make_pair(v,0));
		AdjList[v].push_back(make_pair(u,0));
	}
	printList(nv);

	bfs(1);
	return 0;
}