//Como usar STL para construir uma lista de adjacencia para representacao de GRAFOS
// Traverse the graph BFS....

#include<iostream>
#include<cstdio>
#include<vector>
#include<queue>
#include<climits>

using namespace std;

#define INF INT_MAX

typedef pair<int,int> ii;
typedef vector<ii> vii;
// muitos problemas de grafos requerem uso de vetor de visitados, etc...
typedef vector<int> vi;

// a lista de adjacencia é um vetor de vii !!!
vector<vii> AdjList;

//vetor de vertices (VIS ou NAOVIS)
vi vertices;

// vetor pai para percorrer a trilha que leva ao menor caminho...
vi pai;


void printList(int nv){
	for (int i = 0; i <= nv; ++i){
		printf("%d -> ", i );
		for (int j = 0; j < AdjList[i].size(); ++j){
			printf("(%d %d) -> ", AdjList[i][j].first, AdjList[i][j].second);
		}
		printf("\n");
	}
	printf("\n");
}


void dijkstra(int vert){
	// cria um MIN HEAP onde o prim elemento do par é o peso da aresta e o segundo é o nó u
	priority_queue<ii, vector<ii>, greater<ii> > pq;

	pq.push(ii(0,vert));  // Coloca o vertice inicial na fila, claro com peso 0...
	vertices[vert] = 0; // marca u como visitado

	
	// enquanto tiver elemento na fila...
	while (!pq.empty()){
		ii par = pq.top(); pq.pop(); // estratégia gulosa, sempre pega o de menor peso...
		int w = par.first;
		int u = par.second;
		printf("(peso, u) =  (%d,%d) ** ", w, u);

		// pode acontecer de existir um nó 'zumbi' de peso maior irrelevante..
		if (vertices[u] < w)
			continue; 

		// para todos os adj v de u
		for (int i = 0; i < AdjList[u].size(); ++i){
			int v = AdjList[u][i].first;
			w = AdjList[u][i].second;
			// relaxa os vertices sempre que encontrar um caminho menor...
			if (w+vertices[u] < vertices[v]){
				vertices[v] = w+vertices[u];
				pq.push(ii(vertices[v], v));
				pai[v] = u;
			}
		}
	}
}


int main(int argc, char const *argv[])
{
	int nv;
	int u,v, w;

	cin >> nv;

	AdjList.assign(nv+1,vii());

	vertices.assign(nv+1, INF);
	pai.assign(nv+1, -1);

	// le o grafo... (nao direcionado)
	while(cin >> u >> v >> w){
		AdjList[u].push_back(make_pair(v,w));
		//AdjList[v].push_back(make_pair(u,w));
	}
	printList(nv);

	dijkstra(1);

	printf("\n");
	for (int i = 0; i <= nv; ++i){
		printf("%d **** ", vertices[i]);
	}
	printf("\n");
	return 0;
}

